// lasrc/vt100.c
// (C) 1998 lars brinkhoff

#include <stdio.h>
#include <stdlib.h>

#include "lasrc.h"
#include "image_out_device.h"

static void
pixel_vt100 (Image_out_device *device, int x, int y,
	     double r, double g, double b)
{
  static char c[] = " ,,//xXO8B";
  double i;
  int j;

  i = 0.3 * r + 0.6 * g + 0.1 * b;
  j = (int)((sizeof (c) - 2) * i + .5);

  printf ("\033[%d;%dH", y, x);
  putchar (c[j]);
  fflush (stdout);
}

static void
wait_vt100 (Image_out_device *device)
{
}

static void
close_vt100 (Image_out_device *device)
{
}

Image_out_device *
create_vt100_image_out_device (char *name, int width, int height, int scale,
			       double gamma)
{
  Image_out_device *device;
  
  device = malloc (sizeof (Image_out_device));
  if (device == 0)
    {
      fprintf (stderr, "out of memory!\n");
      exit (1);
    }
  
  device->width = width;
  device->height = height;
  device->scale = scale;
  device->gamma = gamma;

  device->pixel = pixel_vt100;
  device->wait = wait_vt100;
  device->close = close_vt100;

  printf ("\033[2J");
  fflush (stdout);
  return (Image_out_device *)device;
}
