// ascii.c
// (C) 1997, 1998 lars brinkhoff

#include <stdio.h>
#include <stdlib.h>

#include "pix.h"

void
pixel_ascii (void *dummy, int x, int y, double r, double g, double b)
{
  /*
      The more inconsistent shapes are:  ~ ^ * & | ' [ ] < > 0 l y
      Characters that may not appear in a font are:  ^ ` # | { } ~ \ [ ] $ @
      Example:
        $@B%8&WM#*oahkbdpqwmZO0QLCJUYXzcvunxrjft/\|()1{}[]?-_+~<>i!lI;:,"^`'.
  */
//static char c[] = " .x%$#";
  static char c[] = " ,,//xXO8B";
//static char c[] = "B8O%Xx/, ";
  static int last_y = 0;
  double i;
  int j;

  if (y != last_y)
    {
      last_y = y;
      putchar ('\n');
    }

  i = 0.3 * r + 0.6 * g + 0.1 * b;
  j = (int)((sizeof (c) - 2) * i + .5);

  putchar (c[j]);
}

void *
init_ascii (struct Options *options)
{
  if (options->interleave != 1)
    {
      fprintf (stderr,
	       "ASCII output doesn't support interleaved input\n", 
	       options->me);
      exit (1);
    }
  options->pixel = pixel_ascii;
  options->wait = wait_ascii;
  return init_ascii;
}

void
wait_ascii (void *info)
{
}
