// rearr.c
// (C) 1988 lars brinkhoff

#include <stdio.h>
#include <stdlib.h>

struct Options
{
  int width, n;
};

extern char *optarg;
extern int optind, opterr, optopt;
extern getopt ();

void
parse_options (int argc, char *argv[], struct Options *options)
{
  int c;

  /* Defaults. */
  options->width = -1;
  options->n = -1;

  while ((c = getopt (argc, argv, "w:n:")) != EOF)
    switch (c)
      {
      case 'w': options->width = atoi (optarg); break;
      case 'n': options->n = atoi (optarg); break;
      }

  if (options->width < 0)
    {
      fprintf (stderr,
	       "%s: input width must be specified.\n", argv[0]);
      exit (1);
    }

  if (options->n < 0)
    {
      fprintf (stderr,
	       "%s: input n must be specified.\n", argv[0]);
      exit (1);
    }
  
  if (options->width % options->n != 0)
    fprintf (stderr,
	     "%s: warning: width not even multiple of n\n", argv[0]);
}

// bytes per pixel
#define BPP 3

int
main (int argc, char *argv[])
{
  struct Options options;
  int i = 0, j, k, l, m;
  char *buf;
  int n, w;

  parse_options (argc, argv, &options);

  buf = malloc (BPP * options.width * options.n);
  if (buf == 0)
    {
      fprintf (stderr, "out of memory\n");
      exit (1);
    }
      
  while (!feof (stdin))
    {
      buf[i++] = getchar ();
      
      if (i >= BPP * options.width * options.n)
	{
	  n = options.n;
	  w = options.width;
	  
	  for (j = 0; j < n; j++)
	    for (k = 0; k < w / n; k++)
	      for (l = 0; l < n; l++)
		for (m = 0; m < BPP; m++)
		  putchar (buf[BPP * (n * j + n * n * k + l) + m]);

	  i = 0;
	}
    }
  return 0;
}
